#!/usr/bin/perl
# convert fasta sequences to input for testing
# if title is in the right format, also outputs a .bed file with coordinates

if( $#ARGV != 2 ){
	print "Usage: .fa_file output_prefix seqlen\n";
	print "   header lines (starting with \">\")\n";
	print "   should be formatted as >id_chr_start_end_sense\n";
        print "   if so, a bed file will be output as well\n";
	exit;
}

$outname = "$ARGV[1].seq";
$outbed = "$ARGV[1].bed";

$seql = $ARGV[2];

open(IN,"$ARGV[0]") || die "Can't open $ARGV[0]\n";
open(OUT1,">$outname");
open(OUT2,">$outbed");
$ok=1;
while($line = <IN>){
	chomp($line);
	if( $line =~ />/ ){
		@parts = split('_',$line);
		$remainder = "";
		$remainl = 0;
		if( $#parts == 4 ){
			$ok *= 1;
			$chr = $parts[1];
			$start = $parts[2];
			$sense = $parts[4];
		}
		else{
			$start = 0;
			$ok *= 0;
		}
	}
	else{
		$linel = length($line);
		for($j=0; $j< $remainl; $j++){
			$seq = sprintf("%s%s", substr($remainder, $j, $remainl-$j), substr($line, 0, $seql-($remainl-$j)) );
			print OUT1 "$seq\n";
			printf OUT2 ("%s %i %s\n", $chr, $start, $sense);
			$start++;
		}
		for($j=0; $j<= $linel-$seql; $j++){
			$seq = substr($line, $j, $seql);
			print OUT1 "$seq\n";
			printf OUT2 ("%s %i %s\n", $chr, $start, $sense);
			$start++;
		}
		$remainder = substr($line, $j, $seql);
		$remainl = length($remainder);
	}
}
close(IN);
close(OUT1);
close(OUT2);

if( $ok==0 ){
	system("rm $outbed");
}

print "success\n";

exit;


